data "aws_iam_policy_document" "fn3-exploitableConditionConstraint-policy-document" {

  statement {

    actions = [
      "iam:CreatePolicyVersion",
    ]

    effect = "Allow"

    resources = [
      "*",
    ]

    condition {
      test     = "DateGreaterThan"
      variable = "aws:TokenIssueTime"
      values = [
        "2020-01-01T00:00:01Z"
      ]
    }
  }
}





resource "aws_iam_policy" "fn3-exploitableConditionConstraint" {
  name        = "fn3-exploitableConditionConstraint"
  path        = "/"
  description = "Allows privesc via iam:CreatePolicyVersion"
  policy = data.aws_iam_policy_document.fn3-exploitableConditionConstraint-policy-document.json
}

resource "aws_iam_role" "fn3-exploitableConditionConstraint-role" {
  name                = "fn3-exploitableConditionConstraint-role"
  assume_role_policy  = jsonencode({
    Version = "2012-10-17"
    Statement = [
      {
        Action = "sts:AssumeRole"
        Effect = "Allow"
        Sid    = ""
        Principal = {
          AWS = var.aws_assume_role_arn
        }
      },
    ]
  })
}


resource "aws_iam_user" "fn3-exploitableConditionConstraint-user" {
  name = "fn3-exploitableConditionConstraint-user"
  path = "/"
}

resource "aws_iam_access_key" "fn3-exploitableConditionConstraint-user" {
 user = aws_iam_user.fn3-exploitableConditionConstraint-user.name
}


resource "aws_iam_user_policy_attachment" "fn3-exploitableConditionConstraint-user-attach-policy" {
  user       = aws_iam_user.fn3-exploitableConditionConstraint-user.name
  policy_arn = aws_iam_policy.fn3-exploitableConditionConstraint.arn
}

resource "aws_iam_role_policy_attachment" "fn3-exploitableConditionConstraint-role-attach-policy" {
  role       = aws_iam_role.fn3-exploitableConditionConstraint-role.name
  policy_arn = aws_iam_policy.fn3-exploitableConditionConstraint.arn

}  