resource "aws_iam_policy" "fn4-exploitableNotAction" {
  name        = "fn4-exploitableNotAction"
  path        = "/"
  description = "Allows non iam privesc paths like ssm and ec2-connect-instance"

  # Terraform's "jsonencode" function converts a
  # Terraform expression result to valid JSON syntax.
  policy = jsonencode({
    Version = "2012-10-17"
    Statement = [
      {
        NotAction = [
         "iam:Update*",
         "iam:Create*",
         "iam:Attach*"
        ]
        Effect   = "Allow"
        Resource = "*"
      },
    ]
  })
}



resource "aws_iam_role" "fn4-exploitableNotAction-role" {
  name                = "fn4-exploitableNotAction-role"
  assume_role_policy  = jsonencode({
    Version = "2012-10-17"
    Statement = [
      {
        Action = "sts:AssumeRole"
        Effect = "Allow"
        Sid    = ""
        Principal = {
          AWS = var.aws_assume_role_arn
        }
      },
    ]
  })
}


resource "aws_iam_user" "fn4-exploitableNotAction-user" {
  name = "fn4-exploitableNotAction-user"
  path = "/"
}

resource "aws_iam_access_key" "fn4-exploitableNotAction-user" {
 user = aws_iam_user.fn4-exploitableNotAction-user.name
}


resource "aws_iam_user_policy_attachment" "fn4-exploitableNotAction-user-attach-policy" {
  user       = aws_iam_user.fn4-exploitableNotAction-user.name
  policy_arn = aws_iam_policy.fn4-exploitableNotAction.arn
}

resource "aws_iam_role_policy_attachment" "fn4-exploitableNotAction-role-attach-policy" {
  role       = aws_iam_role.fn4-exploitableNotAction-role.name
  policy_arn = aws_iam_policy.fn4-exploitableNotAction.arn

}  