resource "aws_iam_policy" "fp4-nonExploitableResourceConstraint" {
  name        = "fp4-nonExploitableResourceConstraint"
  path        = "/"
  description = "Allows privesc via iam:CreatePolicyVersion"

  # Terraform's "jsonencode" function converts a
  # Terraform expression result to valid JSON syntax.
  policy = jsonencode({
    Version = "2012-10-17"
    Statement = [
      {
        Action = "iam:CreatePolicyVersion"
        Effect   = "Allow"
        Resource = "arn:aws:iam::aws:policy/fp4-*"
      },
    ]
  })
}

resource "aws_iam_role" "fp4-nonExploitableResourceConstraint-role" {
  name                = "fp4-nonExploitableResourceConstraint-role"
  assume_role_policy  = jsonencode({
    Version = "2012-10-17"
    Statement = [
      {
        Action = "sts:AssumeRole"
        Effect = "Allow"
        Sid    = ""
        Principal = {
          AWS = var.aws_assume_role_arn
        }
      },
    ]
  })
}


resource "aws_iam_user" "fp4-nonExploitableResourceConstraint-user" {
  name = "fp4-nonExploitableResourceConstraint-user"
  path = "/"
}

resource "aws_iam_access_key" "fp4-nonExploitableResourceConstraint-user" {
 user = aws_iam_user.fp4-nonExploitableResourceConstraint-user.name
}


resource "aws_iam_user_policy_attachment" "fp4-nonExploitableResourceConstraint-user-attach-policy" {
  user       = aws_iam_user.fp4-nonExploitableResourceConstraint-user.name
  policy_arn = aws_iam_policy.fp4-nonExploitableResourceConstraint.arn
}

resource "aws_iam_role_policy_attachment" "fp4-nonExploitableResourceConstraint-role-attach-policy" {
  role       = aws_iam_role.fp4-nonExploitableResourceConstraint-role.name
  policy_arn = aws_iam_policy.fp4-nonExploitableResourceConstraint.arn

}  